Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 1 | # |
Marcin Wojtas | a86fe0c | 2020-06-02 15:12:06 +0200 | [diff] [blame] | 2 | # Copyright (C) 2016 - 2020 Marvell International Ltd. |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 3 | # |
| 4 | # SPDX-License-Identifier: BSD-3-Clause |
| 5 | # https://spdx.org/licenses |
| 6 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 7 | PLAT_FAMILY := a8k |
Grzegorz Jaszczyk | 3039bce | 2019-11-05 13:14:59 +0100 | [diff] [blame] | 8 | PLAT_INCLUDE_BASE := include/plat/marvell/armada/$(PLAT_FAMILY) |
Grzegorz Jaszczyk | 2d3d86a | 2018-12-09 23:11:20 +0100 | [diff] [blame] | 9 | PLAT_COMMON_BASE := plat/marvell/armada/a8k/common |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 10 | MARVELL_DRV_BASE := drivers/marvell |
Grzegorz Jaszczyk | 3039bce | 2019-11-05 13:14:59 +0100 | [diff] [blame] | 11 | MARVELL_COMMON_BASE := plat/marvell/armada/common |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 12 | |
Konstantin Porotchkin | f51f251 | 2018-11-06 12:25:38 +0200 | [diff] [blame] | 13 | MARVELL_SVC_TEST := 0 |
| 14 | $(eval $(call add_define,MARVELL_SVC_TEST)) |
| 15 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 16 | ERRATA_A72_859971 := 1 |
| 17 | |
| 18 | # Enable MSS support for a8k family |
| 19 | MSS_SUPPORT := 1 |
| 20 | |
| 21 | # Disable EL3 cache for power management |
Marcin Wojtas | a86fe0c | 2020-06-02 15:12:06 +0200 | [diff] [blame] | 22 | BL31_CACHE_DISABLE := 0 |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 23 | $(eval $(call add_define,BL31_CACHE_DISABLE)) |
| 24 | |
| 25 | $(eval $(call add_define,PCI_EP_SUPPORT)) |
| 26 | $(eval $(call assert_boolean,PCI_EP_SUPPORT)) |
| 27 | |
Grzegorz Jaszczyk | 2ed16f5 | 2018-06-29 18:00:33 +0200 | [diff] [blame] | 28 | AP_NUM := 1 |
| 29 | $(eval $(call add_define,AP_NUM)) |
| 30 | |
Konstantin Porotchkin | 6ff50d5 | 2018-10-07 17:54:20 +0300 | [diff] [blame] | 31 | DOIMAGEPATH ?= tools/marvell/doimage |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 32 | DOIMAGETOOL ?= ${DOIMAGEPATH}/doimage |
| 33 | |
Pali Rohár | 85e0a89 | 2020-10-19 17:10:11 +0200 | [diff] [blame] | 34 | include plat/marvell/marvell.mk |
Pali Rohár | 6dca2c6 | 2020-10-21 11:50:40 +0200 | [diff] [blame] | 35 | include tools/marvell/doimage/doimage.mk |
| 36 | |
| 37 | ifeq (${MARVELL_SECURE_BOOT},1) |
| 38 | DOIMAGE_SEC_FLAGS := -c $(DOIMAGE_SEC) |
| 39 | DOIMAGE_LIBS_CHECK = \ |
| 40 | if ! [ -d "/usr/include/mbedtls" ]; then \ |
| 41 | echo "****************************************" >&2; \ |
| 42 | echo "Missing mbedTLS installation! " >&2; \ |
| 43 | echo "Please download it from \"tls.mbed.org\"" >&2; \ |
| 44 | echo "Alternatively on Debian/Ubuntu system install" >&2; \ |
| 45 | echo "\"libmbedtls-dev\" package" >&2; \ |
| 46 | echo "Make sure to use version 2.1.0 or later" >&2; \ |
| 47 | echo "****************************************" >&2; \ |
| 48 | exit 1; \ |
| 49 | else if ! [ -f "/usr/include/libconfig.h" ]; then \ |
| 50 | echo "********************************************************" >&2; \ |
| 51 | echo "Missing Libconfig installation!" >&2; \ |
| 52 | echo "Please download it from \"www.hyperrealm.com/libconfig/\"" >&2; \ |
| 53 | echo "Alternatively on Debian/Ubuntu system install packages" >&2; \ |
| 54 | echo "\"libconfig8\" and \"libconfig8-dev\"" >&2; \ |
| 55 | echo "********************************************************" >&2; \ |
| 56 | exit 1; \ |
| 57 | fi \ |
| 58 | fi |
| 59 | else #MARVELL_SECURE_BOOT |
| 60 | DOIMAGE_LIBS_CHECK = |
| 61 | DOIMAGE_SEC_FLAGS = |
| 62 | endif #MARVELL_SECURE_BOOT |
Pali Rohár | 85e0a89 | 2020-10-19 17:10:11 +0200 | [diff] [blame] | 63 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 64 | ROM_BIN_EXT ?= $(BUILD_PLAT)/ble.bin |
| 65 | DOIMAGE_FLAGS += -b $(ROM_BIN_EXT) $(NAND_DOIMAGE_FLAGS) $(DOIMAGE_SEC_FLAGS) |
| 66 | |
Luka Kovacic | 49358fb | 2020-01-13 20:37:35 +0100 | [diff] [blame] | 67 | # Check whether to build system_power.c for the platform |
Luka Kovacic | 7a75c06 | 2020-07-03 17:02:54 +0200 | [diff] [blame] | 68 | ifneq ("$(wildcard $(BOARD_DIR)/board/system_power.c)","") |
Luka Kovacic | 49358fb | 2020-01-13 20:37:35 +0100 | [diff] [blame] | 69 | SYSTEM_POWER_SUPPORT = 1 |
| 70 | else |
| 71 | SYSTEM_POWER_SUPPORT = 0 |
| 72 | endif |
| 73 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 74 | # This define specifies DDR type for BLE |
| 75 | $(eval $(call add_define,CONFIG_DDR4)) |
| 76 | |
| 77 | MARVELL_GIC_SOURCES := drivers/arm/gic/common/gic_common.c \ |
| 78 | drivers/arm/gic/v2/gicv2_main.c \ |
| 79 | drivers/arm/gic/v2/gicv2_helpers.c \ |
| 80 | plat/common/plat_gicv2.c |
| 81 | |
Grzegorz Jaszczyk | 2d3d86a | 2018-12-09 23:11:20 +0100 | [diff] [blame] | 82 | PLAT_INCLUDES := -I$(BOARD_DIR) \ |
Grzegorz Jaszczyk | d3d6a1c | 2019-03-28 16:09:38 +0100 | [diff] [blame] | 83 | -I$(BOARD_DIR)/board \ |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 84 | -I$(PLAT_COMMON_BASE)/include \ |
Antonio Nino Diaz | 50a4d1a | 2019-02-01 12:22:22 +0000 | [diff] [blame] | 85 | -I$(PLAT_INCLUDE_BASE)/common |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 86 | |
| 87 | PLAT_BL_COMMON_SOURCES := $(PLAT_COMMON_BASE)/aarch64/a8k_common.c \ |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 88 | drivers/ti/uart/aarch64/16550_console.S |
| 89 | |
Grzegorz Jaszczyk | 2d3d86a | 2018-12-09 23:11:20 +0100 | [diff] [blame] | 90 | BLE_PORTING_SOURCES := $(BOARD_DIR)/board/dram_port.c \ |
| 91 | $(BOARD_DIR)/board/marvell_plat_config.c |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 92 | |
| 93 | MARVELL_MOCHI_DRV += $(MARVELL_DRV_BASE)/mochi/cp110_setup.c |
| 94 | |
Christine Gharzuzi | 9a772df | 2018-06-25 13:39:37 +0300 | [diff] [blame] | 95 | BLE_SOURCES := drivers/mentor/i2c/mi2cv.c \ |
| 96 | $(PLAT_COMMON_BASE)/plat_ble_setup.c \ |
| 97 | $(MARVELL_MOCHI_DRV) \ |
| 98 | $(PLAT_COMMON_BASE)/plat_pm.c \ |
| 99 | $(MARVELL_DRV_BASE)/ap807_clocks_init.c \ |
| 100 | $(MARVELL_DRV_BASE)/thermal.c \ |
| 101 | $(PLAT_COMMON_BASE)/plat_thermal.c \ |
| 102 | $(BLE_PORTING_SOURCES) \ |
| 103 | $(MARVELL_DRV_BASE)/ccu.c \ |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 104 | $(MARVELL_DRV_BASE)/io_win.c |
| 105 | |
| 106 | BL1_SOURCES += $(PLAT_COMMON_BASE)/aarch64/plat_helpers.S \ |
| 107 | lib/cpus/aarch64/cortex_a72.S |
| 108 | |
| 109 | MARVELL_DRV := $(MARVELL_DRV_BASE)/io_win.c \ |
| 110 | $(MARVELL_DRV_BASE)/iob.c \ |
| 111 | $(MARVELL_DRV_BASE)/mci.c \ |
| 112 | $(MARVELL_DRV_BASE)/amb_adec.c \ |
| 113 | $(MARVELL_DRV_BASE)/ccu.c \ |
| 114 | $(MARVELL_DRV_BASE)/cache_llc.c \ |
Grzegorz Jaszczyk | f47d855 | 2018-06-13 16:00:48 +0200 | [diff] [blame] | 115 | $(MARVELL_DRV_BASE)/comphy/phy-comphy-cp110.c \ |
Grzegorz Jaszczyk | 65b9afa | 2019-04-12 16:53:49 +0200 | [diff] [blame] | 116 | $(MARVELL_DRV_BASE)/mc_trustzone/mc_trustzone.c \ |
| 117 | $(MARVELL_DRV_BASE)/mg_conf_cm3/mg_conf_cm3.c |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 118 | |
Grzegorz Jaszczyk | 2d3d86a | 2018-12-09 23:11:20 +0100 | [diff] [blame] | 119 | BL31_PORTING_SOURCES := $(BOARD_DIR)/board/marvell_plat_config.c |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 120 | |
Luka Kovacic | 49358fb | 2020-01-13 20:37:35 +0100 | [diff] [blame] | 121 | ifeq ($(SYSTEM_POWER_SUPPORT),1) |
Luka Kovacic | 7a75c06 | 2020-07-03 17:02:54 +0200 | [diff] [blame] | 122 | BL31_PORTING_SOURCES += $(BOARD_DIR)/board/system_power.c |
Luka Kovacic | 49358fb | 2020-01-13 20:37:35 +0100 | [diff] [blame] | 123 | endif |
| 124 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 125 | BL31_SOURCES += lib/cpus/aarch64/cortex_a72.S \ |
| 126 | $(PLAT_COMMON_BASE)/aarch64/plat_helpers.S \ |
| 127 | $(PLAT_COMMON_BASE)/aarch64/plat_arch_config.c \ |
| 128 | $(PLAT_COMMON_BASE)/plat_pm.c \ |
| 129 | $(PLAT_COMMON_BASE)/plat_bl31_setup.c \ |
| 130 | $(MARVELL_COMMON_BASE)/marvell_gicv2.c \ |
| 131 | $(MARVELL_COMMON_BASE)/mrvl_sip_svc.c \ |
| 132 | $(MARVELL_COMMON_BASE)/marvell_ddr_info.c \ |
| 133 | $(BL31_PORTING_SOURCES) \ |
| 134 | $(MARVELL_DRV) \ |
| 135 | $(MARVELL_MOCHI_DRV) \ |
| 136 | $(MARVELL_GIC_SOURCES) |
| 137 | |
| 138 | # Add trace functionality for PM |
| 139 | BL31_SOURCES += $(PLAT_COMMON_BASE)/plat_pm_trace.c |
| 140 | |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 141 | # Force builds with BL2 image on a80x0 platforms |
| 142 | ifndef SCP_BL2 |
| 143 | $(error "Error: SCP_BL2 image is mandatory for a8k family") |
| 144 | endif |
| 145 | |
| 146 | # MSS (SCP) build |
| 147 | include $(PLAT_COMMON_BASE)/mss/mss_a8k.mk |
| 148 | |
| 149 | # BLE (ROM context execution code, AKA binary extension) |
Konstantin Porotchkin | 01851db | 2018-10-03 14:21:42 +0300 | [diff] [blame] | 150 | BLE_PATH ?= $(PLAT_COMMON_BASE)/ble |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 151 | |
| 152 | include ${BLE_PATH}/ble.mk |
| 153 | $(eval $(call MAKE_BL,e)) |
| 154 | |
Pali Rohár | 06a38e2 | 2020-11-23 19:45:28 +0100 | [diff] [blame] | 155 | clean realclean distclean: mrvl_clean |
| 156 | |
| 157 | .PHONY: mrvl_clean |
Pali Rohár | 6dca2c6 | 2020-10-21 11:50:40 +0200 | [diff] [blame] | 158 | mrvl_clean: |
| 159 | @echo " Doimage CLEAN" |
| 160 | ${Q}${MAKE} PLAT=${PLAT} --no-print-directory -C ${DOIMAGEPATH} clean |
| 161 | |
Pali Rohár | 06a38e2 | 2020-11-23 19:45:28 +0100 | [diff] [blame] | 162 | ${DOIMAGETOOL}: FORCE |
Pali Rohár | 6dca2c6 | 2020-10-21 11:50:40 +0200 | [diff] [blame] | 163 | @$(DOIMAGE_LIBS_CHECK) |
| 164 | ${Q}${MAKE} --no-print-directory -C ${DOIMAGEPATH} |
| 165 | |
Pali Rohár | 06a38e2 | 2020-11-23 19:45:28 +0100 | [diff] [blame] | 166 | .PHONY: mrvl_flash |
Pali Rohár | 3666d48 | 2020-10-29 16:50:19 +0100 | [diff] [blame] | 167 | mrvl_flash: ${BUILD_PLAT}/${BOOT_IMAGE} ${DOIMAGETOOL} |
Konstantin Porotchkin | f69ec58 | 2018-06-07 18:31:14 +0300 | [diff] [blame] | 168 | ${DOIMAGETOOL} ${DOIMAGE_FLAGS} ${BUILD_PLAT}/${BOOT_IMAGE} ${BUILD_PLAT}/${FLASH_IMAGE} |
| 169 | |
Pali Rohár | 06a38e2 | 2020-11-23 19:45:28 +0100 | [diff] [blame] | 170 | .PHONY: FORCE |
| 171 | FORCE:; |